ServerEvents.recipes((event) => {
  
  // =========================================
  // Misc Stuff
  // =========================================

  // Vanilla Beehive
  event
    .shaped("minecraft:beehive", [
      "AAA", 
      "BCB", 
      "AAA"
    ], 
    {
      A: "the_bumblezone:beehive_beeswax",
      B: "the_bumblezone:porous_honeycomb_block",
      C: "the_bumblezone:empty_honeycomb_brood_block",
    })
    .id("minecraft:beehive");

  // Cog Block
  event
    .shaped("6x supplementaries:cog_block", [
      "ABA", 
      "BCB", 
      "ABA"
    ], 
    {
      A: "#forge:ingots/copper",
      B: "#forge:gears/copper",
      C: "#forge:storage_blocks/redstone",
    })
    .id("supplementaries:cog_block");

  //Regions Unexplored Blackstone Cluster (fix recipe conflict with polished blackstone)
  event
    .shapeless("regions_unexplored:blackstone_cluster", [
      "minecraft:blackstone",
      "minecraft:blackstone",
    ])
    .id("regions_unexplored:blackstone_cluster");

  // Supplementaries Antique Ink
  event.recipes.create
    .filling("supplementaries:antique_ink", [
      Fluid.of("create_enchantment_industry:ink", 250),
      "minecraft:glass_bottle",
    ])
    .id("supplementaries:antique_ink");

  // Supplementaries Lock Block
  event
    .shapeless("supplementaries:lock_block", [
      "create:andesite_casing",
      "monobank:replacement_lock",
    ])
    .id("supplementaries:lock_block");

  // Supplementaries Key
  event
    .shaped("supplementaries:key", [
      "A ", 
      "BC", 
      "BC"
    ], 
    {
      A: "#forge:gears/gold",
      B: "#forge:rods/blaze",
      C: "#forge:nuggets/gold",
    })
    .id("supplementaries:key");

  // =========================================
  // Dimensional Dungeon Stuff
  // =========================================

  // Block Portal Keyhole
  event
    .shapeless("dimdungeons:block_portal_keyhole", [
      "dimdungeons:block_gilded_portal",
      "minecraft:ender_eye",
      "supplementaries:lock_block",
    ])
    .id("dimdungeons:recipe_block_portal_keyhole");

  // Blank Portal Key
  event
    .shapeless("dimdungeons:item_portal_key", [
      "minecraft:name_tag",
      "supplementaries:key",
    ])
    .id("dimdungeons:recipe_item_blank_key");

  // =========================================
  // Alexs Caves Hazmat Suit Recipes
  // =========================================

  // Hazmat mask
  event
    .shaped("alexscaves:hazmat_mask", [
      "AAA", 
      "ABA"
    ], 
    {
      A: "alexscaves:polymer_plate",
      B: "thermal:hazmat_helmet",
    })
    .id("alexscaves:hazmat_mask");

  // Hazmat chestplate
  event
    .shaped("alexscaves:hazmat_chestplate", [
      "A A", 
      "ABA", 
      "AAA"
    ], 
    {
      A: "alexscaves:polymer_plate",
      B: "thermal:hazmat_chestplate",
    })
    .id("alexscaves:hazmat_chestplate");

  // Hazmat leggings
  event
    .shaped("alexscaves:hazmat_leggings", [
      "AAA", 
      "ABA", 
      "A A"
    ], 
    {
      A: "alexscaves:polymer_plate",
      B: "thermal:hazmat_leggings",
    })
    .id("alexscaves:hazmat_leggings");

  // Hazmat boots
  event
    .shaped("alexscaves:hazmat_boots", [
      "ABA", 
      "A A"
    ], 
    {
      A: "alexscaves:polymer_plate",
      B: "thermal:hazmat_boots",
    })
    .id("alexscaves:hazmat_boots");

// Adding back an older Labels recipe
  event
    .shaped("8x labels:label", [
      "AAA", 
      "ABA",
      "AAA"
    ], 
    {
      A: "minecraft:paper",
      B: 'supplementaries:antique_ink',
    })
    .id("labels:label");


 // Final Quest Recipe
 event.recipes.create
 .mechanical_crafting(
   "kubejs:generikb",
   ["ABCDE", 
    "FGHIJ", 
    "KLMNO", 
    "PQRST", 
    "UVWXY"],
   {
     A: 'thermal:beekeeper_helmet',
     B: 'seadwellers:depth_helmet',
     C: 'ad_astra:jet_suit_helmet',
     D: 'alexscaves:hazmat_mask',
     E: 'alexscaves:primordial_helmet',
     F: '#minecards:smeltable_cards',
     G: 'seadwellers:depth_pickaxe',
     H: 'alexscaves:tremorsaurus_egg',
     I: 'deeperdarker:warden_pickaxe',
     J: '#moa_decor_toys:plushies',
     K: 'naturalist:teddy_bear',
     L: 'alexscaves:radgill_bucket',
     M: 'alexscaves:heart_of_iron',
     N: 'alexscaves:immortal_embryo',
     O: 'starmetal:star_metal',
     P: '#tarotcards:tarot_cards',
     Q: 'rats:ratlantis_pickaxe',
     R: 'alexscaves:darkened_apple',
     S: 'undergarden:forgotten_pickaxe',
     T: 'undergarden:gronglet',
     U: 'ad_astra:moon_desh_ore',
     V: 'ad_astra:mars_ostrum_ore',
     W: 'ad_astra:venus_calorite_ore',
     X: 'ad_astra:glacio_ice_shard_ore',
     Y: 'ad_astra:mercury_iron_ore'
   }
 )
 .id("kubejs:generikb");   

});